// Generated by CoffeeScript 1.9.3
(function() {
  var assign, convert, excel, fs, isArray, isObject, parseKeyName, process, transpose, write;

  fs = require("fs");

  excel = require('excel');

  isObject = function(obj) {
    return Object.prototype.toString.call(obj) === '[object Object]';
  };

  isArray = function(obj) {
    return Object.prototype.toString.call(obj) === '[object Array]';
  };

  parseKeyName = function(key) {
    var index;
    index = key.match(/\[(\d+)\]$/);
    switch (false) {
      case !index:
        return [true, key.split('[')[0], Number(index[1])];
      case key.slice(-2) !== '[]':
        return [true, key.slice(0, -2), void 0];
      default:
        return [false, key, void 0];
    }
  };

  assign = function(obj, key, value) {
    var i, index, j, keyIsList, keyName, ref, ref1, ref2;
    if (typeof key !== 'object') {
      key = key.split('.');
    }
    ref = parseKeyName(key.shift()), keyIsList = ref[0], keyName = ref[1], index = ref[2];
    if (key.length) {
      if (keyIsList) {
        if (isArray(obj[keyName])) {
          if (!obj[keyName][index]) {
            for (i = j = ref1 = obj[keyName].length, ref2 = index; ref1 <= ref2 ? j <= ref2 : j >= ref2; i = ref1 <= ref2 ? ++j : --j) {
              obj[keyName].push({});
            }
          }
        } else {
          obj[keyName] = (function() {
            var k, ref3, results;
            results = [];
            for (i = k = 0, ref3 = index; 0 <= ref3 ? k <= ref3 : k >= ref3; i = 0 <= ref3 ? ++k : --k) {
              results.push({});
            }
            return results;
          })();
        }
        return assign(obj[keyName][index], key, value);
      } else {
        if (obj[keyName] == null) {
          obj[keyName] = {};
        }
        return assign(obj[keyName], key, value);
      }
    } else {
      if (keyIsList && (index != null)) {
        console.error("WARNING: Unexpected key path terminal containing an indexed list for <" + keyName + ">");
        console.error("WARNING: Indexed arrays indicate a list of objects and should not be the last element in a key path");
        console.error("WARNING: The last element of a key path should be a key name or flat array. E.g. alias, aliases[]");
      }
      obj[keyName] = keyIsList && (index == null) ? value.split(';') : value;
      return obj;
    }
  };

  transpose = function(matrix) {
    var i, j, ref, results, t;
    results = [];
    for (i = j = 0, ref = matrix[0].length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
      results.push((function() {
        var k, len, results1;
        results1 = [];
        for (k = 0, len = matrix.length; k < len; k++) {
          t = matrix[k];
          results1.push(t[i]);
        }
        return results1;
      })());
    }
    return results;
  };

  convert = function(data, isColOriented) {
    var index, item, j, k, keys, len, len1, result, row, rows, value;
    if (isColOriented == null) {
      isColOriented = false;
    }
    if (isColOriented) {
      data = transpose(data);
    }
    keys = data[0];
    rows = data.slice(1);
    result = [];
    for (j = 0, len = rows.length; j < len; j++) {
      row = rows[j];
      item = {};
      for (index = k = 0, len1 = row.length; k < len1; index = ++k) {
        value = row[index];
        assign(item, keys[index], value);
      }
      result.push(item);
    }
    return result;
  };

  write = function(data, dst) {
    return fs.writeFile(dst, JSON.stringify(data, null, 2), function(err) {
      if (err) {
        return console.error("Error writing file " + dst, err);
      } else {
        return console.log("Updated " + dst);
      }
    });
  };

  process = function(src, dst, isColOriented) {
    if (isColOriented == null) {
      isColOriented = false;
    }
    if (!fs.existsSync(src)) {
      return console.error("Cannot find src file " + src);
    } else {
      return excel(src, function(err, data) {
        if (err) {
          return console.error("Error reading " + src, err);
        } else {
          return write(convert(data, isColOriented), dst);
        }
      });
    }
  };

  exports.assign = assign;

  exports.convert = convert;

  exports.parseKeyName = parseKeyName;

  exports.process = process;

  exports.transpose = transpose;

}).call(this);
